<?php
/*
Plugin Name: Pop Notify
Description: Display Notify style ads within your blog
Version: 1.8
Author: Andrew Lewin
Author URI: http://andrewlewin.info
License: GPLv2
*/

if(!class_exists('WP_List_Table')){
    require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

define ( 'ALPN_INSERTJS', plugin_dir_url(__FILE__).'js');
define ( 'ALPN_INSERTCSS', plugin_dir_url(__FILE__).'css');
define ( 'ALPN_INSERTIMAGE', plugin_dir_url(__FILE__).'images');
define ( 'ALPN_ALT_API', 'http://sellmycode.com/jtwsgtee/plugin-api/' );

if($_REQUEST['alpn_action'] == 'insert'){

	//print_r($_POST[ "alpn_insert_section" ]);exit;

	require_once(ABSPATH . "wp-admin" . '/includes/image.php');
  require_once(ABSPATH . "wp-admin" . '/includes/file.php');
  require_once(ABSPATH . "wp-admin" . '/includes/media.php');

		if(!empty($_FILES['alpn_banner_image_upload']['tmp_name'])){
			$overide = array('test_form' => false);
			$file = wp_handle_upload($_FILES['alpn_banner_image_upload'], $overide);
		} 


    $newData = array(
			'fr_picture' => $file['url']  ,
			'fr_text' => urlencode(str_replace("'","\'",$_POST[ "alpn_insert_section" ][ 'alpn_redirect_url' ])),
		    'fr_status' => $_POST[ "alpn_insert_section" ][ 'alpn_ad_status' ]  ,
		    'fr_destination' => $_POST[ "alpn_insert_section" ][ 'alpn_ad_destination' ] ,
		    'fr_window_location' => $_POST[ "alpn_insert_section" ][ 'alpn_window_location' ]
	);

	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";
	
	$wpdb->insert(
		$tableName,
		$newData
	);
	
	add_action('admin_notices', 'showAdminMessagesAdded'); 
}

if($_REQUEST['alpn_action'] == 'delete'){

	require_once(ABSPATH . "wp-admin" . '/includes/image.php');
  require_once(ABSPATH . "wp-admin" . '/includes/file.php');
  require_once(ABSPATH . "wp-admin" . '/includes/media.php');


	$adId = $_REQUEST[ "ad" ];

	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";
	
	$wpdb->query(
		"
		DELETE FROM $tableName 
		WHERE fr_id = $adId 
		"
	);
	add_action('admin_notices', 'showAdminMessagesDeleted'); 
}

if($_REQUEST['alpn_action'] == 'bulkDelete'){

	require_once(ABSPATH . "wp-admin" . '/includes/image.php');
  require_once(ABSPATH . "wp-admin" . '/includes/file.php');
  require_once(ABSPATH . "wp-admin" . '/includes/media.php');


	$adArray= explode(",",$_POST['adsForDelete']);

	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";

	for($i=0;$i<sizeof($adArray);$i++){

		$adId = $adArray[$i];

		$wpdb->query(
			"
			DELETE FROM $tableName 
			WHERE fr_id = $adId 
			"
		);

	}
	add_action('admin_notices', 'showAdminMessagesMultiDeleted'); 
	
}

if($_REQUEST['alpn_action'] == 'doUpdate'){

	require_once(ABSPATH . "wp-admin" . '/includes/image.php');
  require_once(ABSPATH . "wp-admin" . '/includes/file.php');
  require_once(ABSPATH . "wp-admin" . '/includes/media.php');
	
	 if(!empty($_FILES['alpn_banner_image_upload']['tmp_name'])){
		 
		$overide = array('test_form' => false);
		$file = wp_handle_upload($_FILES['alpn_banner_image_upload'], $overide);

		$imageSqlLocation = "fr_picture = '" . $file['url'] . "',";
		//print_r($file); exit;
	} else {
		$imageSqlLocation = "";
	}


	$adId = $_REQUEST[ "ad" ];

	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";

	$message = urlencode(str_replace("'","\'",$_POST[ "alpn_insert_section" ][ 'alpn_redirect_url' ]));
	//print_r($message);exit;
	$status = $_POST[ "alpn_insert_section" ][ 'alpn_ad_status' ];
	$adDestination = $_POST[ "alpn_insert_section" ][ 'alpn_ad_destination' ];
	$windowLocation = $_POST[ "alpn_insert_section" ][ 'alpn_window_location' ];

	$wpdb->query(
		"
		UPDATE $tableName 
		SET fr_text 	= '$message',
		fr_destination = '$adDestination',
		{$imageSqlLocation}
		fr_status 	= '$status',
		fr_window_location 	= '$windowLocation'
		WHERE fr_id = $adId  
		"
	);

	add_action('admin_notices', 'showAdminMessagesUpdate');  
}


if($_REQUEST['alpn_action'] == 'pause' || $_REQUEST['alpn_action'] == 'resume' ){

	require_once(ABSPATH . "wp-admin" . '/includes/image.php');
  require_once(ABSPATH . "wp-admin" . '/includes/file.php');
  require_once(ABSPATH . "wp-admin" . '/includes/media.php');

	
	 if($_REQUEST['alpn_action'] == 'pause'){
		$status = "Paused";
	 } else {
		$status = "Running";
	 }

	$adId = $_REQUEST[ "ad" ];

	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";

	$wpdb->query(
		"
		UPDATE $tableName SET 
		fr_status 	= '$status'
		WHERE fr_id = $adId  
		"
	);
}



class FB_Table extends WP_List_Table {

	public $options;
    

    function __construct(){
        global $status, $page;

		
                
        //Set parent defaults
        parent::__construct( array(
            'singular'  => 'ad',     //singular name of the listed records
            'plural'    => 'ads',    //plural name of the listed records
            'ajax'      => false        //does this table support ajax?
        ) );

		$this->options = get_option('alpn_settings_section');
		$this->register_settings_and_fields();
        
    }

    function column_default($item, $column_name){
        switch($column_name){
            case 'fr_picture':
            case 'fr_text':
			case 'fr_status':
			case 'fr_destination':
                return $item[$column_name];
            default:
                return print_r($item,true); //Show the whole array for troubleshooting purposes
        }
    }
    
        
    function column_fr_picture($item){
        
        //Build row actions
        $actions = array(
            'edit'      => sprintf('<a href="?page=%s&alpn_action=%s&ad=%s">Edit</a>',$_REQUEST['page'],'edit',$item['fr_id']),
            'delete'    => sprintf('<a href="?page=%s&alpn_action=%s&ad=%s">Delete</a>',$_REQUEST['page'],'delete',$item['fr_id'])
        );

		if ($item['fr_status'] == "Paused"){
			$actions['resume'] = sprintf('<a href="?page=%s&alpn_action=%s&ad=%s">Resume</a>',$_REQUEST['page'],'resume',$item['fr_id']);
		} else {
			$actions['pause'] = sprintf('<a href="?page=%s&alpn_action=%s&ad=%s">Pause</a>',$_REQUEST['page'],'pause',$item['fr_id']);
		}
        
        //Return the title contents
        return sprintf('<img src="%1$s" style="max-width:45px;" /> %2$s',
            /*$1%s*/ $item['fr_picture'],
            /*$3%s*/ $this->row_actions($actions)
        );
    }

	function column_fr_text($item){
        
        //Return the title contents
		return str_replace("\\",'',urldecode($item["fr_text"]));
    }

	function column_fr_status($item){
        
        //Return the title contents
        return $item['fr_status'];
    }

	function column_fr_destination($item){
        
        //Return the title contents
        return $item['fr_destination'];
    }
    
    function column_cb($item){
        return sprintf(
            '<input type="checkbox" name="%1$s[]" value="%2$s" />',
            /*$1%s*/ $this->_args['singular'],  //Let's simply repurpose the table's singular label ("movie")
            /*$2%s*/ $item['fr_id']                //The value of the checkbox should be the record's id
        );
    }
    
    function get_columns(){
        $columns = array(
            'cb'        => '<input type="checkbox" />', //Render a checkbox instead of text
            'fr_picture'     => 'Picture',
            'fr_text'    => 'Message',
            'fr_destination'  => 'Destination',
            'fr_status'  => 'Status'
        );
        return $columns;
    }
    
    function get_sortable_columns() {
        $sortable_columns = array(
            'fr_picture'     => array('fr_picture',false),     //true means its already sorted
            'fr_text'    => array('fr_text',false),
            'fr_status'  => array('fr_status',true),
			'fr_destination'  => array('fr_destination',false)
        );
        return $sortable_columns;
    }
    
    
    function get_bulk_actions() {
        $actions = array(
            'delete'    => 'Delete'
        );
        return $actions;
    }
    
    
    function process_bulk_action() {
        
		
        //Detect when a bulk action is being triggered...
        if( 'delete'===$this->current_action() ) {
			$adsForDelete = implode(",", $_GET['ad']);
				?>

				
		<div id="wpbody">
			<div id="wpbody-content">
			<div id="screen-meta" class="metabox-prefs">

				<div id="contextual-help-wrap" class="hidden no-sidebar">
					<div id="contextual-help-back"></div>
					<div id="contextual-help-columns">
						<div class="contextual-help-tabs">
							<ul>
													</ul>
						</div>

						
						<div class="contextual-help-tabs-wrap">
												</div>
					</div>
				</div>
					<div id="screen-options-wrap" class="hidden">
			<form id="adv-settings" action="" method="post">
						<h5>Show on screen</h5>
						<div class="metabox-prefs">
					<label for="description-hide"><input class="hide-column-tog" name="description-hide" id="description-hide" value="description" checked="checked" type="checkbox">Description</label>
					<br class="clear">
				</div>
					<div><input id="screenoptionnonce" name="screenoptionnonce" value="b85e70ccae" type="hidden"></div>
			</form>
			</div>
					</div>
					<div id="screen-meta-links">
						<div id="screen-options-link-wrap" class="hide-if-no-js screen-meta-toggle">
				<a href="#screen-options-wrap" id="show-settings-link" class="show-settings">Screen Options</a>
				</div>
					</div>
						<div class="wrap">
					<div id="icon-plugins" class="icon32"><br>
					</div><h2>Delete Ads</h2>	
					<p>Are you sure you want to delete ads?</p>
					<form method="post" action="?page=alpn_pn_ads_section&tab=ads" style="display:inline;">
						<input name="adsForDelete" value="<?php echo $adsForDelete;?>" type="hidden">
						<input name="alpn_action" value="bulkDelete" type="hidden">
					<input name="submit" id="submit" class="button" value="Yes, Delete these ads" type="submit">				</form>
					<form method="post" action="?page=alpn_pn_ads_section&tab=ads" style="display:inline;">
						<input name="submit" id="submit" class="button" value="No, Return me to my Ads list" type="submit">				</form>
				</div>
					
				<div class="clear"></div></div><!-- wpbody-content -->
				<div class="clear"></div>
			</div>
				<?php
					exit;
            //wp_die('Items deleted (or they would be if we had items to delete)!');
        }
        
    }

	public function register_settings_and_fields(){

		if ($_REQUEST['tab'] == "addNew" || $_REQUEST['alpn_action'] == "update"){
			register_setting('alpn_insert_section','alpn_insert_section', array($this,'alpn_settings_section_validate_settings'));		
			add_settings_section('alpn_insert_section', 'Add New Ad', array($this,'main_section_cb'), __FILE__);		
			add_settings_field('alpn_banner_image', 'Banner Image', array($this, 'alpn_banner_image'), __FILE__, 'alpn_insert_section');
			add_settings_field('alpn_ad_text', 'Text', array($this, 'alpn_ad_text'), __FILE__, 'alpn_insert_section');
			add_settings_field('alpn_ad_destination', 'Destination', array($this, 'alpn_ad_destination'), __FILE__, 'alpn_insert_section');
			add_settings_field('alpn_window_location', 'Open Window In', array($this, 'alpn_window_location'), __FILE__, 'alpn_insert_section');
			add_settings_field('alpn_ad_status', 'Status', array($this, 'alpn_ad_status'), __FILE__, 'alpn_insert_section');
		}  else {
			register_setting('alpn_settings_section','alpn_settings_section', array($this,'alpn_settings_section_validate_settings'));		
			add_settings_section('alpn_settings_section', 'Edit Settings', array($this,'main_section_cb'), __FILE__);		
			add_settings_field('alpn_enable_setting', 'Disable Pop Notify', array($this, 'alpn_enable_setting'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_show_in_home', 'Display In Home Page', array($this, 'alpn_show_in_home'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_show_all_pages', 'Display In All Pages', array($this, 'alpn_show_all_pages'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_show_all_posts', 'Display In All Posts', array($this, 'alpn_show_all_posts'), __FILE__, 'alpn_settings_section');

			add_settings_field('alpn_ad_position', 'Ad Position', array($this, 'alpn_ad_position'), __FILE__, 'alpn_settings_section');

			add_settings_field('alpn_rotation_speed', 'Rotation Speed', array($this, 'alpn_rotation_speed'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_startup_delay', 'Delay Time', array($this, 'alpn_startup_delay'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_number_rotations', 'Number of Rotations', array($this, 'alpn_number_rotations'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_show_no_times', 'Times To Display', array($this, 'alpn_show_no_times'), __FILE__, 'alpn_settings_section');
			add_settings_field('alpn_show_max_ads', 'Max Number of Ads on Screen', array($this, 'alpn_show_max_ads'), __FILE__, 'alpn_settings_section');				

			add_settings_field('alpn_clear_cookies', 'Clear Visitor Cookies On Your Machine', array($this, 'alpn_clear_cookies'), __FILE__, 'alpn_settings_section');
		}
		
	}

	public function alpn_settings_section_validate_settings($plugin_options){
		
		if ( !empty( $_POST[ 'alpn_hidden_clear_cookies' ] ) ){
			//clear cookies

			setcookie ("alpn_pn_ad", "", time() - 3600);
		}

		return $plugin_options;
	}
	
		public function main_section_cb(){
		
	}

	public function alpn_ad_position(){

		$items = array('Bottom Left', 'Top Left', 'Bottom Right', 'Top Right');
		echo "<select name='alpn_settings_section[alpn_ad_position]'>";
		foreach($items as $item){
			$selected = ( $this->options['alpn_ad_position'] === $item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select>";

	}

	public function alpn_window_location(){

		$items = array('New Window', 'Same Window');
		echo "<select name='alpn_insert_section[alpn_window_location]' width='100' style='width: 100px;'>";
		foreach($items as $item){
			$selected = ( $this->options['alpn_window_location'] === $item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select> ";

	}

	public function alpn_ad_status(){

		$items = array('Running', 'Paused');
		echo "<select name='alpn_insert_section[alpn_ad_status]' width='100' style='width: 100px;'>";
		foreach($items as $item){
			$selected = ( $this->options['alpn_ad_status'] === $item) ? 'selected="selected"' : '';
			echo "<option value='$item' $selected>$item</option>";
		}
		echo "</select> ";

	}

	public function alpn_banner_image(){

		echo '<input type="file" name="alpn_banner_image_upload"/><br/><br/>';
		if ( isset($this->options['alpn_banner_image']) ){
			echo "<img src='{$this->options['alpn_banner_image']}' alt='' />";
		}
	}

	public function alpn_ad_text(){
		echo "<input size='40' name='alpn_insert_section[alpn_redirect_url]' type='text' value='{$this->options['alpn_redirect_url']}'/> ";
	}

	public function alpn_ad_destination(){
		echo "<input size='40' name='alpn_insert_section[alpn_ad_destination]' type='text' value='{$this->options['alpn_ad_destination']}'/> <i>(Include http://)</i>";
	}

	public function alpn_enable_setting(){
		if (isset($this->options['alpn_enable_setting']) && $this->options['alpn_enable_setting']=="true"){
			$checked = "checked";
		} else {
			$checked = "";
		}	
		echo "<input size='40' name='alpn_settings_section[alpn_enable_setting]' type='checkbox' value='true' {$checked}/>";
	}

	public function alpn_show_in_home(){
		if (isset($this->options['alpn_show_in_home']) && $this->options['alpn_show_in_home']=="true"){
			$checked = "checked";
		} else {
			$checked = "";
		}	
		echo "<input size='40' name='alpn_settings_section[alpn_show_in_home]' type='checkbox' value='true' {$checked}/>";
	}

	public function alpn_show_all_pages(){
		if (isset($this->options['alpn_show_all_pages']) && $this->options['alpn_show_all_pages']=="true"){
			$checked = "checked";
		} else {
			$checked = "";
		}	
		echo "<input size='40' name='alpn_settings_section[alpn_show_all_pages]' type='checkbox' value='true' {$checked}/>";
	}

	public function alpn_show_all_posts(){
		if (isset($this->options['alpn_show_all_posts']) && $this->options['alpn_show_all_posts']=="true"){
			$checked = "checked";
		} else {
			$checked = "";
		}	
		echo "<input size='40' name='alpn_settings_section[alpn_show_all_posts]' type='checkbox' value='true' {$checked}/>";
	}

	public function alpn_startup_delay(){

		$delay = (isset($this->options['alpn_startup_delay'])) ? $this->options['alpn_startup_delay'] : 2;
		echo "<input id = 'alpn_startup_delay' size='2'  name='alpn_settings_section[alpn_startup_delay]' type='text' value='{$delay}'/> <i>(Seconds)</i><div style='width: 25%;' id='slider-range-max-delay'></div>";

	}

	public function alpn_rotation_speed(){
		$speed = (isset($this->options['alpn_rotation_speed'])) ? $this->options['alpn_rotation_speed'] : 5;
		echo "<input id = 'alpn_rotation_speed' size='2' name='alpn_settings_section[alpn_rotation_speed]' type='text' value='{$speed}'/> <i>(Seconds)</i><div style='width: 25%;' id='slider-range-max-speed'></div>";

	}

	public function alpn_number_rotations(){
		$rotations = (isset($this->options['alpn_number_rotations'])) ? $this->options['alpn_number_rotations'] : 1;
		echo "<input id = 'alpn_number_rotations' size='2' name='alpn_settings_section[alpn_number_rotations]' type='text' value='{$rotations}'/> <i>(leave on zero for infinite rotations)</i><div style='width: 25%;' id='slider-range-max-rotations'></div>";

	}

	public function alpn_show_no_times(){
		$noTimes = (isset($this->options['alpn_show_no_times'])) ? $this->options['alpn_show_no_times'] : 0;
		echo "<input id = 'alpn_show_no_times' size='2'  name='alpn_settings_section[alpn_show_no_times]' type='text' value='{$noTimes}'/> <i>(leave on zero for infinite displays)</i><div style='width: 25%;' id='slider-range-no-times'></div>";

	}

	public function alpn_show_max_ads(){
		$noTimes = (isset($this->options['alpn_show_max_ads'])) ? $this->options['alpn_show_max_ads'] : 3;
		echo "<input id = 'alpn_show_max_ads' size='2'  name='alpn_settings_section[alpn_show_max_ads]' type='text' value='{$noTimes}'/>";

	}

	public function alpn_clear_cookies(){
		echo '<input type="button" class="button" value="Clear Cookies" name="alpn_clear_cookies" onClick="javascript:alpn_clearCookies();" style="width:auto;" />';
	}

	public function setupAd(){
		
		$adData = getRunningAds();

		setupJavascript($adData);

	}

    function prepare_items() {

		global $wpdb;
	
		$tableName = $wpdb->prefix . "aslfb_ad_records";
        
        /**
         * First, lets decide how many records per page to show
         */
        $per_page = 5;
        

        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        

        $this->_column_headers = array($columns, $hidden, $sortable);
        

        $this->process_bulk_action();
        

		$orderby = (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'fr_status'; //If no sort, default to title
        $order = (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'asc'; //If no order, default to asc

		$sql = "SELECT fr_id 	, fr_picture, fr_text , fr_destination, fr_status FROM " . $tableName . " order by $orderby $order";

		global $wpdb;
	
		$data = $wpdb->get_results($sql, ARRAY_A);

        $current_page = $this->get_pagenum();

        $total_items = count($data);
        
        $data = array_slice($data,(($current_page-1)*$per_page),$per_page);
        
        $this->items = $data;

        $this->set_pagination_args( array(
            'total_items' => $total_items,                  //WE have to calculate the total number of items
            'per_page'    => $per_page,                     //WE have to determine how many items to show on a page
            'total_pages' => ceil($total_items/$per_page)   //WE have to calculate the total number of pages
        ) );
    }
    
}

function alpn_mytheme_admin_tabs( $current = 'ads' ) {
	if($current == 'addNew' || $current == ''){
		$current = 'ads';
	}
    $tabs = array( 'ads' => 'Ads', 'settings' => 'Settings' );
    $links = array();
    foreach( $tabs as $tab => $name ) :
        if ( $tab == $current ) :
            $links[] = "<a class='nav-tab nav-tab-active' href='?page=alpn_pn_ads_section&tab=$tab'>$name</a>";
        else :
            $links[] = "<a class='nav-tab' href='?page=alpn_pn_ads_section&tab=$tab'>$name</a>";
        endif;
    endforeach;
    echo '<h2>';
    foreach ( $links as $link )
        echo $link;
    echo '</h2>';
}

//-------------------------------- install plugin section

register_activation_hook(__FILE__, 'alpn_tab_table_install');

function alpn_tab_table_install(){
	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";
	
	$sql = "CREATE TABLE IF NOT EXISTS `$tableName` (
  `fr_id` int(12) NOT NULL AUTO_INCREMENT,
  `fr_picture` varchar(200) NOT NULL,
  `fr_text` varchar(100) NOT NULL,
  `fr_destination` varchar(100) NOT NULL,
  `fr_status` varchar(12) NOT NULL,
  `fr_window_location` varchar(20) NOT NULL,
  PRIMARY KEY (`fr_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;";

require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

dbDelta($sql);


}

//-------------------------------- posts meta box section

//hook to add a meta box to the post
add_action( 'add_meta_boxes', 'alpn_post_pn_ad_setup' );

function alpn_post_pn_ad_setup() {

	//create a custom meta box
	add_meta_box( 'alpn_post_pn_ad_setup', 'Pop Notify Ad Section', 'alpn_post_pn_ad_setup_function', 'post', 'normal', 'high' );

}

function alpn_post_pn_ad_setup_function( $post ) {

	//retrieve the meta data values if they exist
	$alpn_post_pn_ad_show = get_post_meta( $post->ID, '_alpn_post_pn_ad_show', true );

	echo '<h4><b>Check the box below for the Pop Notify Ad to show for this specific post:</b></h4>';

	if (isset($alpn_post_pn_ad_show) && $alpn_post_pn_ad_show=="true"){
		$checked = "checked";
	} else {
		$checked = "";
	}

	?>
	<p><b>Display in Post </b>:</b> <input type="checkbox" name="alpn_post_pn_ad_show" value="true" size="40" <?php echo esc_attr( $checked ); ?>/> </p>

	<?php
}

//hook to save the meta box data
add_action( 'save_post', 'alpn_post_pn_ad_save_meta' );

function alpn_post_pn_ad_save_meta( $post_id ) {

	//verify the meta data is set
	if ( isset( $_POST['alpn_post_pn_ad_show'] ) ) {
	
		//save the meta data
		update_post_meta( $post_id, '_alpn_post_pn_ad_show', strip_tags( $_POST['alpn_post_pn_ad_show'] ) );
	
	} else {
		delete_post_meta( $post_id, '_alpn_post_pn_ad_show' );

	}

}

//-------------------------------- pages meta box section

//hook to add a meta box to the post
add_action( 'add_meta_boxes', 'alpn_pages_pn_ad_setup' );

function alpn_pages_pn_ad_setup() {

	//create a custom meta box
	add_meta_box( 'alpn_pages_pn_ad_setup', 'Pop Notify Ad Section', 'alpn_pages_pn_ad_setup_function', 'page', 'normal', 'high' );

}

function alpn_pages_pn_ad_setup_function( $page ) {

	//retrieve the meta data values if they exist
	$alpn_pages_pn_ad_show = get_post_meta( $page->ID, '_alpn_pages_pn_ad_show', true );

	echo '<h4><b>Check the box below for the PopNotify Ad to show for this specific post:</b></h4>';

	if (isset($alpn_pages_pn_ad_show) && $alpn_pages_pn_ad_show=="true"){
		$checked = "checked";
	} else {
		$checked = "";
	}

	?>
	<p><b>Display in Post </b>:</b> <input type="checkbox" name="alpn_pages_pn_ad_show" value="true" size="40" <?php echo esc_attr( $checked ); ?>/> </p>

	<?php
}

//hook to save the meta box data
add_action( 'save_post', 'alpn_pages_pn_ad_save_meta' );

function alpn_pages_pn_ad_save_meta( $page_id ) {

	//verify the meta data is set
	if ( isset( $_POST['alpn_pages_pn_ad_show'] ) ) {
	
		//save the meta data
		update_post_meta( $page_id, '_alpn_pages_pn_ad_show', strip_tags( $_POST['alpn_pages_pn_ad_show'] ) );
	
	} else {
		delete_post_meta( $page_id, '_alpn_pages_pn_ad_show' );

	}

}


function getRunningAds (){
	global $wpdb;
	
	$tableName = $wpdb->prefix . "aslfb_ad_records";

	$sql = "SELECT fr_id 	, fr_picture, fr_text, fr_destination , fr_status, fr_window_location  FROM " . $tableName . " where fr_status = 'Running'";
	
	$data = $wpdb->get_results($sql, ARRAY_A);

	return $data;

}

function setupJavascript($adData){

	if (alpn_enable_setting()=='true'){
		return;
	}

	$showOnHomePage = alpn_show_in_home();
	$showinAllPosts = alpn_show_all_posts();
	$showinAllPages = alpn_show_all_pages();

	if (is_category() || is_archive()){
		return;
	}

	if ((is_home() || is_front_page()) && $showOnHomePage=='false'){
		return;
	}
	
	if (is_single() && $showinAllPosts=='false' && (!is_front_page())){
		
		//check the posts for the meta
		global $wp_query;

		$post_ID = $wp_query->post->ID;
		
		$showAd = get_post_meta( $post_ID, '_alpn_post_pn_ad_show', true );
		
		if($showAd!='true'){
			return;
		}
		
	}

	if (is_page() && $showinAllPages=='false' && (!is_front_page())){
		
		global $wp_query;

		$post_ID = $wp_query->post->ID;

		$showAd = get_post_meta( $post_ID, '_alpn_pages_pn_ad_show', true );
		if($showAd!='true'){
			return;
		}
	}

	$startupDelay = alpn_startup_delay()*1000;
	$rotationSpeed = alpn_rotation_speed()*1000;
	$numberRotations = alpn_number_rotations();
	$noTimes = alpn_show_no_times();
	$maxAdCount = alpn_show_max_ads();

	$currentDisplays = 0;

	if (isset($_COOKIE['alpn_pn_ad']) && $noTimes != 0){
		if ($noTimes <= $_COOKIE['alpn_pn_ad']){
			return;
		} else {
			$currentDisplays = $_COOKIE['alpn_pn_ad'] + 1;
		}
	}

	$trackingCode = generateRandomStringPn(8);

	wp_deregister_script( 'jquery' );
	wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js', array(), '1.7.2', false);
	wp_enqueue_script( 'jquery' );
	//wp_enqueue_script('alpn_insert_script', ALPN_INSERTJS .'/notify.js');
	wp_enqueue_style('alpn_insert_style',  ALPN_INSERTCSS .'/main-min.css');

	$postTitle = getPostTitle();

	//print_r($title);exit;

	$baseUrl = plugin_dir_url(__FILE__);
	$wordpressUrl = str_replace("\\","/",ABSPATH);


	$addArrayOutput = "";
	$addArrayLength = count($adData);

	$imageLocation = ALPN_INSERTIMAGE;

	for($i=0;$i<$addArrayLength;$i++){

		$textData = urldecode($adData[$i]["fr_text"]);
		
		$textData = str_replace('"','\"',$textData);

		$adPosition = strtolower(alpn_ad_position());

		

		if ($adPosition == "bottom left"){
			$adPosition = 'jQuery("#fbads").css("bottom","50px");jQuery("#fbads").css("left","50px");';
		} else if ($adPosition == "top left"){
			$adPosition = 'jQuery("#fbads").css("top","50px");jQuery("#fbads").css("left","50px");';
		} else if ($adPosition == "bottom right"){
			$adPosition = 'jQuery("#fbads").css("bottom","50px");jQuery("#fbads").css("left","");jQuery("#fbads").css("right","50px");';
		} else if ($adPosition == "top right"){
			$adPosition = 'jQuery("#fbads").css("top","50px");jQuery("#fbads").css("left","");jQuery("#fbads").css("right","50px");';
		} 

		$textData = str_replace("\\","",$textData);
		$textData = str_replace("'","\'",$textData);
		
		//print_r($adData);exit;
		$addArrayOutput .= 'adArray['.$i.'] = ["'.$adData[$i]["fr_picture"].'",  "'.$textData.'", "'.$adData[$i]["fr_destination"].'", "'.$adData[$i]["fr_window_location"].'"];';
		//echo count($adData);exit;
		
		
	}

	//print_r($addArrayOutput);exit;

$optin = <<<HTML
		'<div id="fbads"></div><script type="text/javascript" src="{$baseUrl}/js/notify-min.js"></script>
		<script>
				if (!window.console) console = {log: function() {}}; 
				jQuery.noConflict();{$adPosition}
				var adArray=new Array({$addArrayLength});var currPos=0;var currIndex=0;var ie=(navigator.appName=="Microsoft Internet Explorer");var pos="fixed";var maxPopupCount,allPopupCounts;var mainTimer;var noTimes={$numberRotations};document.cookie="alpn_pn_ad={$currentDisplays}; path=/; expires="+(new Date()).toGMTString().replace(/\d{4}/,"2020");allPopupCounts={$addArrayLength};maxPopupCount={$maxAdCount};if(allPopupCounts<maxPopupCount){maxPopupCount=allPopupCounts}{$addArrayOutput};jQuery(document).ready(function(a){popup=a("#fbads");popup.setPopup({$rotationSpeed});mainTimer=setTimeout(runAd,{$startupDelay})});function runAd(){if(currPos>=adArray.length){currPos=0;currIndex++;if(noTimes>0&&currIndex==noTimes){return}}if(jQuery("#fbads > div").size()==maxPopupCount){clearTimeout(mainTimer);mainTimer=setTimeout(runAd,parseInt({$rotationSpeed})+700);return}var a="";jQuery("#bannerIcon").remove();if(adArray[currPos][0]!=""){a=adArray[currPos][0];popup.callPopup(adArray[currPos][1],a,adArray[currPos][2],adArray[currPos][3])}else{popup.callIconPopup(adArray[currPos][1],adArray[currPos][2],"{$imageLocation}/at-symbol.png",adArray[currPos][3])}currPos++;clearTimeout(mainTimer);mainTimer=setTimeout(runAd,parseInt({$rotationSpeed})+700)};

		</script>
		'

HTML;

add_action( 'wp_head', create_function( '', "echo $optin;" ) );
	
}

function getPostTitle(){

	if (is_home()){
		return 'Home';
	}

	if (is_single() || is_page()){
		
		//check the posts for the meta
		global $wp_query;

		$post_ID = $wp_query->post->ID;

		return the_title('','',false);		
	}
}

function alpn_show_in_home(){
	
	$options = get_option('alpn_settings_section');

	
	
	if (isset($options['alpn_show_in_home']) && $options['alpn_show_in_home']=="true"){
		return 'true';
	} else {
		
		return 'false';
	}

}

function alpn_show_all_pages(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_show_all_pages']) && $options['alpn_show_all_pages']=="true"){
		return 'true';
	} else {
		return 'false';
	}

}

function alpn_show_all_posts(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_show_all_posts']) && $options['alpn_show_all_posts']=="true"){
		return 'true';
	} else {
		return 'false';
	}

}

function alpn_startup_delay(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_startup_delay']) && $options['alpn_startup_delay']!=''){
		return $options['alpn_startup_delay'];
	} else {
		return '2';
	}

}

function alpn_rotation_speed(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_rotation_speed']) && $options['alpn_rotation_speed']!=''){
		return $options['alpn_rotation_speed'];
	} else {
		return '5';
	}

}

function alpn_number_rotations(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_number_rotations']) && $options['alpn_number_rotations']!=''){
		return $options['alpn_number_rotations'];
	} else {
		return '0';
	}

}

function alpn_show_no_times(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_show_no_times']) && $options['alpn_show_no_times']!=''){
		return $options['alpn_show_no_times'];
	} else {
		return '0';
	}

}

function alpn_show_max_ads(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_show_max_ads']) && $options['alpn_show_max_ads']!=''){
		return $options['alpn_show_max_ads'];
	} else {
		return '3';
	}

}

function alpn_enable_setting(){
	
	$options = get_option('alpn_settings_section');

	if (isset($options['alpn_enable_setting']) && $options['alpn_enable_setting']=="true"){
		return 'true';
	} else {
		return 'false';
	}

}

function alpn_ad_position(){
	
	$options = get_option('alpn_settings_section');
	
	if (isset($options['alpn_ad_position'])){
		return $options['alpn_ad_position'];
	} else {
		return 'Bottom Left';
	}

}


/** ************************ REGISTER Page ****************************
 *******************************************************************************
 * Now we just need to define an admin page. For this example, we'll add a top-level
 * menu item to the bottom of the admin menus.
 */
function alpn_add_menu_items(){
    add_menu_page('Pop Notify', 'Pop Notify', 'manage_options', 'alpn_pn_ads_section', 'alpn_render_options_page');

	add_submenu_page( 'alpn_pn_ads_section', // parent menu slug
						  'Pop Notify Settings', // title of page
						  'Settings', // label in menu
						  'manage_options', // permissions required
						  'alpn_pn_ads_section', // slug
						  'alpn_render_options_page' ); // function to render page

		add_submenu_page( 'alpn_pn_ads_section', // parent menu slug
						  'PopNotify Help', // title of page
						  'PopNotify Help', // label in menu
						  'manage_options', // permissions required
						  'alpn_pn_helppage', // slug
						  'alpn_render_help_page' ); // function to render page
} add_action('admin_menu', 'alpn_add_menu_items');


add_action('admin_init','instantiate_alpn_pn_ads');

function instantiate_alpn_pn_ads(){
	global $testListTable;
	$testListTable = new FB_Table();
}

add_action( 'wp_enqueue_scripts', 'alpn_setup_ads' );

function alpn_setup_ads(){
	FB_Table::setupAd();
	
}

//------------------------------------- custom update section

// Hook into the plugin update check
add_filter('pre_set_site_transient_update_plugins', 'alpn_altapi_check');

function alpn_altapi_check( $transient ) {

    // Check if the transient contains the 'checked' information
    // If no, just return its value without hacking it
    if( empty( $transient->checked ) )
        return $transient;
    
    // The transient contains the 'checked' information
    // Now append to it information form your own API
    
    $plugin_slug = plugin_basename( __FILE__ );
    
    // POST data to send to your API
    $args = array(
        'action' => 'update-check',
        'plugin_name' => $plugin_slug,
        'version' => $transient->checked[$plugin_slug],
    );
    
    // Send request checking for an update
    $response = alpn_altapi_request( $args );
    
    // If response is false, don't alter the transient
    if( false !== $response ) {
        $transient->response[$plugin_slug] = $response;
    }
    
    return $transient;
}

// Send a request to the alternative API, return an object
function alpn_altapi_request( $args ) {

    // Send request
    $request = wp_remote_post( ALPN_ALT_API, array( 'body' => $args ) );
    
    // Make sure the request was successful
    if( is_wp_error( $request )
    or
    wp_remote_retrieve_response_code( $request ) != 200
    ) {
        // Request failed
        return false;
    }
    
    // Read server response, which should be an object
    $response = unserialize( wp_remote_retrieve_body( $request ) );
    if( is_object( $response ) ) {
        return $response;
    } else {
        // Unexpected response
        return false;
    }
}


// Hook into the plugin details screen
add_filter('plugins_api', 'alpn_altapi_information', 10, 3);

function alpn_altapi_information( $false, $action, $args ) {

    $plugin_slug = plugin_basename( __FILE__ );

    // Check if this plugins API is about this plugin
    if( $args->slug != $plugin_slug ) {
        return false;
    }
        
    // POST data to send to your API
    $args = array(
        'action' => 'plugin_information',
        'plugin_name' => $plugin_slug,
        'version' => $transient->checked[$plugin_slug],
    );
    
    // Send request for detailed information
    $response = alpn_altapi_request( $args );
    
    // Send request checking for information
    $request = wp_remote_post( ALPN_ALT_API, array( 'body' => $args ) );

    return $response;
}



function alpn_render_help_page(){

		?>
		
		<div class="wrap">
			<div id="icon-options-general" class="icon32"><br /></div>
			<h2> Pop Notify Help</h2>
			<br/>
			<h3> Settings Tutorial:</h3>
			<br/>
			<div>
					<iframe width="420" height="315" src="http://www.youtube.com/embed/SwDTS7V5qgU" frameborder="0" allowfullscreen></iframe>			
			</div>
			<br/>
			<h3> Support:</h3>
			<br/>
			<div>
					<a href="http://www.yourbrainhelp.com/">Help Desk Support</a>			
			</div>
	
			
		</div>

		<?php
}

function alpn_render_options_page(){
    global $testListTable;
    //Create an instance of our package class...
    
    //Fetch, prepare, sort, and filter our data...
    $testListTable->prepare_items();
    
    ?>
    <div class="wrap">
        
        <div id="icon-users" class="icon32"><br/></div>
        <h2>Pop Notify <a href="?page=alpn_pn_ads_section&tab=addNew" class="add-new-h2">Add New</a></h2>		
		<br/>
			<h3>Warning: If you are not seeing ads, use the clear cookie button under the settings tab as you may have reached max visists. or set Times To Display to 0 under settings</h3>
        <h2 class="nav-tab-wrapper">
		
		<?php echo alpn_mytheme_admin_tabs($_GET['tab']); ?>
        <!-- Forms are NOT created automatically, so you need to wrap the table in one to use features like bulk actions -->
        <?php if (  $_GET['page'] == 'alpn_pn_ads_section' ) :
				if ( isset ( $_GET['tab'] ) ) :
					$tab = $_GET['tab'];
				else:
					$tab = 'ads';
				endif;
				
				
				if ($_REQUEST['alpn_action'] == "edit"){
					$tab = 'updateAd';
				}
				switch ( $tab ) :
					case 'ads' :
						alpn_ads_options($testListTable);
						break;
					case 'settings' :
						alpn_settings_options();
						break;
					case 'addNew' :
						alpn_addNew_options();
						break;
					case 'updateAd' :
						alpn_updateAd_options();
						break;
				endswitch;
			endif;
	?>
        
    </div>
	<script>
			function alpn_clearCookies(){document.getElementById("alpn_hidden_clear_cookies").value="true";document.getElementById("alpn_optionsForm").submit()};
			
		</script>
    <?php
}

function alpn_ads_options($testListTable){

	?>

        <!-- Forms are NOT created automatically, so you need to wrap the table in one to use features like bulk actions -->
        <form id="movies-filter" method="get">
            <!-- For plugins, we also need to ensure that the form posts back to our current page -->
            <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
            <!-- Now we can render the completed list table -->
            <?php $testListTable->display() ?>
        </form>
    <?php	

}

function alpn_updateAd_options(){
	global $wpdb;
	//get the current database details
	$result =  $wpdb->get_row( "
	select fr_id, fr_picture , fr_text, fr_destination, fr_status, fr_window_location from " . $wpdb->prefix . "aslfb_ad_records where fr_id = " . $_REQUEST['ad'], ARRAY_A);
	?>

        <!-- Forms are NOT created automatically, so you need to wrap the table in one to use features like bulk actions -->
        <form method="post" action="?page=alpn_pn_ads_section&tab=ads" enctype="multipart/form-data" id="optionsForm">
			<input name='alpn_action' value='doUpdate' type='hidden'/>
			<input name='ad' value='<?php echo $result['fr_id']; ?>' type='hidden'/>
			<input name="option_page" value="alpn_insert_section" type="hidden"><input name="action" value="update" type="hidden"><input id="_wpnonce" name="_wpnonce" value="ba3419ae10" type="hidden"><input name="_wp_http_referer" value="/wordpress/wp-admin/admin.php?page=alpn_pn_ads_section&amp;tab=addNew" type="hidden">			<h3>Add Ad</h3>
			<table class="form-table">
				<tbody>
					<tr valign="top">
						<th scope="row">Banner Image</th>
						<td>
							<input name="alpn_banner_image_upload" type="file">
							<br><br></i></i>
							<?php
									if ( $result['fr_picture'] != "" ){
										echo "<img src='{$result['fr_picture']}' alt='' />";
									}
							?>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row">Text</th>
						<td>
							<input size="40" name="alpn_insert_section[alpn_redirect_url]" value="<?php echo str_replace("\\",'',urldecode($result["fr_text"])); ?>" type="text"> 
						</td>
					</tr>
					<tr valign="top">
						<th scope="row">Destination</th>
						<td>
							<input size="40" name="alpn_insert_section[alpn_ad_destination]" value="<?php echo $result['fr_destination']; ?>" type="text"> <i>(Include http://)</i>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row">Open Window In</th>
						<td>
							<select name="alpn_insert_section[alpn_window_location]" width="100" style="width: 100px;"><?php
							$items = array('New Window', 'Same Window');
							foreach($items as $item){
								$selected = ( $result['fr_window_location'] === $item) ? 'selected="selected"' : '';
								echo "<option value='$item' $selected>$item</option>";
							}
		
		
						?></select>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row">Status</th>
						<td>
							<select name="alpn_insert_section[alpn_ad_status]" width="100" style="width: 100px;"><?php
							$items = array('Paused', 'Running');
							foreach($items as $item){
								$selected = ( $result['fr_status'] === $item) ? 'selected="selected"' : '';
								echo "<option value='$item' $selected>$item</option>";
							}
		
		
						?></select>
						</td>
					</tr>					
				</tbody>
			</table>			
			
			<p class="submit">
				<input name="submitButton" type="submit" class="button-primary" value="Save Changes"/>
			</p>
		</form>
    <?php	

}

function alpn_addNew_options(){

	?>

        <!-- Forms are NOT created automatically, so you need to wrap the table in one to use features like bulk actions -->
        <form method="post" action="?page=alpn_pn_ads_section&tab=addNew" enctype="multipart/form-data" id="optionsForm">
			<input name='alpn_action' value='insert' type='hidden'/>
			<?php settings_fields('alpn_insert_section'); ?>
			<?php do_settings_sections(__FILE__); ?>
			
			<p class="submit">
				<input name="submitButton" type="submit" class="button-primary" value="Save Changes"/>
			</p>
		</form>
    <?php	

}

function alpn_settings_options(){

		wp_deregister_script( 'jquery' );
		wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js', array(), '1.7.2', false);
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script('jquery-ui', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.6/jquery-ui.min.js', array('jquery'), '1.8.6');
		wp_enqueue_style('jquery-style', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.7/themes/redmond/jquery-ui.css');
?>

        <!-- Forms are NOT created automatically, so you need to wrap the table in one to use features like bulk actions -->
        <form method="post" action="options.php" enctype="multipart/form-data" id="alpn_optionsForm">
			<input id='alpn_hidden_clear_cookies' name='alpn_hidden_clear_cookies' type='hidden'/>
			<br/>
			<h3>You may also toggle Pop Notify on/off on individual posts and pages in the post editor</h3>
			<br/>
			<?php settings_fields('alpn_settings_section'); ?>
			<?php do_settings_sections(__FILE__); ?>
			
			<p class="submit">
				<input name="submitButton" type="submit" class="button-primary" value="Save Changes"/>
			</p>
		</form>
    <?php	

}

//----------------------------------  Message function section


function showMessage($message, $errormsg = false)
{
	if ($errormsg) {
		echo '<div id="message" class="error">';
	}
	else {
		echo '<div id="message" class="updated fade">';
	}

	echo "<p><strong>$message</strong></p></div>";
}   

function showAdminMessagesUpdate()
{

       showMessage("Record Updated",false);
    
}

function showAdminMessagesAdded()
{
       showMessage("Record Added",false);
}

function showAdminMessagesDeleted()
{
       showMessage("Record Deleted",false);
}

function showAdminMessagesMultiDeleted()
{
    // Only show to admins
       showMessage("Records Deleted",false);
}

//----------------------------------  Util function section

function generateRandomStringPn($length = 10, $letters = '1234567890qwertyuiopasdfghjklzxcvbnm')
{
  $s = '';
  $lettersLength = strlen($letters)-1;
 
  for($i = 0 ; $i < $length ; $i++)
  {
  $s .= $letters[rand(0,$lettersLength)];
  }
 
  return $s;
}
